config/routes.rb
Rails.application.routes.draw do
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  get :ping, controller: :heartbeat

  # Defines the root path route ("/")
  root "forms#index"

  get "forms/new" => "forms/change_name#new", as: :new_form
  post "forms/new" => "forms/change_name#create"

  scope "forms/:form_id" do
    get "/" => "forms#show", as: :form
    get "/change-name" => "forms/change_name#edit", as: :change_form_name
    post "/change-name" => "forms/change_name#update"

    scope "/live" do
      get "/" => "forms/live#show_form", as: :live_form
      get "/pages" => "forms/live#show_pages", as: :live_form_pages
    end

    get "/submission-email" => "forms/submission_email#new", as: :submission_email_form
    post "/submission-email" => "forms/submission_email#create"
    get "/confirm-submission-email" => "forms/submission_email#submission_email_code", as: :submission_email_code
    post "/confirm-submission-email" => "forms/submission_email#confirm_submission_email_code", as: :confirm_submission_email_code
    get "/submission-email-confirmed" => "forms/submission_email#submission_email_confirmed", as: :submission_email_confirmed
    get "/email-code-sent" => "forms/submission_email#submission_email_code_sent", as: :submission_email_code_sent

    get "/delete" => "forms/delete_confirmation#delete", as: :delete_form
    delete "/delete" => "forms/delete_confirmation#destroy", as: :destroy_form
    get "/privacy-policy" => "forms/privacy_policy#new", as: :privacy_policy
    post "/privacy-policy" => "forms/privacy_policy#create"
    get "/make-live" => "forms/make_live#new", as: :make_live
    post "/make-live" => "forms/make_live#create", as: :make_live_create
    get "/what-happens-next" => "forms/what_happens_next#new", as: :what_happens_next
    post "/what-happens-next" => "forms/what_happens_next#create", as: :what_happens_next_create
    get "/contact-details" => "forms/contact_details#new", as: :contact_details
    post "/contact-details" => "forms/contact_details#create", as: :contact_details_create
    get "/declaration" => "forms/declaration#new", as: :declaration
    post "/declaration" => "forms/declaration#create", as: :declaration_create

    scope "/pages" do
      get "/" => "pages#index", as: :form_pages
      post "/" => "forms#mark_pages_section_completed"
      post "/move-page" => "pages#move_page", as: :move_page

      scope "/new" do
        get "/type-of-answer" => "pages/type_of_answer#new", as: :type_of_answer_new
        post "/type-of-answer" => "pages/type_of_answer#create", as: :type_of_answer_create
        get "/text-settings" => "pages/text_settings#new", as: :text_settings_new
        post "/text-settings" => "pages/text_settings#create", as: :text_settings_create
        get "/date-settings" => "pages/date_settings#new", as: :date_settings_new
        post "/date-settings" => "pages/date_settings#create", as: :date_settings_create
        get "/selections-settings" => "pages/selections_settings#new", as: :selections_settings_new
        post "/selections-settings" => "pages/selections_settings#create", as: :selections_settings_create
        get "/address-settings" => "pages/address_settings#new", as: :address_settings_new
        post "/address-settings" => "pages/address_settings#create", as: :address_settings_create
        get "/name-settings" => "pages/name_settings#new", as: :name_settings_new
        post "/name-settings" => "pages/name_settings#create", as: :name_settings_create
        get "/" => "pages#new", as: :new_page
        post "/" => "pages#create", as: :create_page
      end

      get "/new-condition" => "pages/conditions#routing_page", as: :routing_page
      post "/new-condition" => "pages/conditions#set_routing_page", as: :set_routing_page

      scope "/:page_id" do
        scope "/conditions" do
          get "/new" => "pages/conditions#new", as: :new_condition
          post "/new" => "pages/conditions#create", as: :create_condition
          get "/:condition_id/edit" => "pages/conditions#edit", as: :edit_condition
          put "/:condition_id" => "pages/conditions#update", as: :update_condition
        end

        scope "/edit" do
          get "/type-of-answer" => "pages/type_of_answer#edit", as: :type_of_answer_edit
          post "/type-of-answer" => "pages/type_of_answer#update", as: :type_of_answer_update
          get "/text-settings" => "pages/text_settings#edit", as: :text_settings_edit
          post "/text-settings" => "pages/text_settings#update", as: :text_settings_update
          get "/date-settings" => "pages/date_settings#edit", as: :date_settings_edit
          post "/date-settings" => "pages/date_settings#update", as: :date_settings_update
          get "/selections-settings" => "pages/selections_settings#edit", as: :selections_settings_edit
          post "/selections-settings" => "pages/selections_settings#update", as: :selections_settings_update
          get "/address-settings" => "pages/address_settings#edit", as: :address_settings_edit
          post "/address-settings" => "pages/address_settings#update", as: :address_settings_update
          get "/name-settings" => "pages/name_settings#edit", as: :name_settings_edit
          post "/name-settings" => "pages/name_settings#update", as: :name_settings_update
          get "/" => "pages#edit", as: :edit_page
          patch "/" => "pages#update", as: :update_page
        end

        scope "/delete" do
          get "/" => "forms/delete_confirmation#delete", as: :delete_page
          delete "/" => "forms/delete_confirmation#destroy", as: :destroy_page
        end
      end
    end
  end

  resources :users, only: %i[index edit update]

  # Page routes
  match "/403", to: "errors#forbidden", as: :error_403, via: :all
  match "/404", to: "errors#not_found", as: :error_404, via: :all
  match "/500", to: "errors#internal_server_error", as: :error_500, via: :all
end

app/models/condition.rb
class Condition < ActiveResource::Base
  self.site = Settings.forms_api.base_url
  self.prefix = "/api/v1/forms/:form_id/pages/:page_id/"
  self.include_format_in_path = false
  headers["X-API-Token"] = Settings.forms_api.auth_key

  belongs_to :page
end

app/controllers/pages/conditions_controller.rb
class Pages::ConditionsController < PagesController
  before_action :can_add_page_routing
  def routing_page
    render template: "pages/conditions/routing_page", locals: { form: @form }
  end

  def set_routing_page
    routing_page = Page.find(params[:form][:routing_page_id], params: { form_id: @form.id })
    redirect_to new_condition_path(@form, routing_page)
  end

  def new
    condition_form = Pages::ConditionsForm.new(form: @form, page:)
    render template: "pages/conditions/new", locals: { condition_form: }
  end

  def create
    condition_form = Pages::ConditionsForm.new(condition_form_params)

    if condition_form.submit
      redirect_to form_pages_path(@form)
    else
      render template: "pages/conditions/new", locals: { condition_form: }, status: :unprocessable_entity
    end
  end

  def edit
    condition = Condition.find(params[:condition_id], params: { form_id: @form.id, page_id: page.id })

    condition_form = Pages::ConditionsForm.new(form: @form, page:, record: condition, answer_value: condition.answer_value, goto_page_id: condition.goto_page_id)

    render template: "pages/conditions/edit", locals: { condition_form: }
  end

  def update
    condition = Condition.find(params[:condition_id], params: { form_id: @form.id, page_id: page.id })

    form_params = condition_form_params.merge(record: condition)

    condition_form = Pages::ConditionsForm.new(form_params)

    if condition_form.update
      redirect_to form_pages_path(@form)
    else
      render template: "pages/conditions/edit", locals: { condition_form: }, status: :unprocessable_entity
    end
  end

private

  def can_add_page_routing
    authorize @form, :can_add_page_routing_conditions?
  end

  def condition_form_params
    params.require(:pages_conditions_form).permit(:answer_value, :goto_page_id).merge(form: @form, page:)
  end
end

app/views/pages/conditions/edit.html.erb
<% set_page_title(title_with_error_prefix(t('page_titles.routing_page'), condition_form.errors&.any?)) %>
<% content_for :back_link, govuk_back_link_to(form_pages_path(condition_form.form.id)) %>

<div class="govuk-grid-row">
  <div class="govuk-grid-column-two-thirds">
    <%= form_with(model: condition_form, url: update_condition_path(condition_form.form.id, condition_form.page.id, condition_form.record.id), method: "PUT") do |f| %>
      <% if condition_form&.errors.any? %>
        <%= f.govuk_error_summary %>
      <% end %>

      <h1 class="govuk-heading-l">
        <span class="govuk-caption-l"><%= condition_form.form.name %></span>
        <%= t("page_titles.routing_page_edit", question_position: condition_form.page.position) %>
      </h1>

      <%= govuk_summary_list(actions: false) do |summary_list|
        summary_list.with_row do |row|
          row.with_key { t("new_condition.routing_page_text") }
          row.with_value { condition_form.page.question_text }
        end;
      end %>

      <%= f.govuk_collection_select :answer_value, condition_form.routing_answer_options, :value, :label %>
      <%= f.govuk_collection_select :goto_page_id, condition_form.goto_page_options, :id, :question_text %>
      <%= f.govuk_submit t("save_and_continue") %>
    <% end %>
  </div>
</div>

app/views/pages/conditions/new.html.erb
<% set_page_title(title_with_error_prefix(t('page_titles.routing_page'), condition_form.errors&.any?)) %>
<% content_for :back_link, govuk_back_link_to(routing_page_path(condition_form.form.id)) %>

<div class="govuk-grid-row">
  <div class="govuk-grid-column-two-thirds">
    <%= form_with(model: condition_form, url: create_condition_path(condition_form.form.id), method: 'POST') do |f| %>
      <% if condition_form&.errors.any? %>
        <%= f.govuk_error_summary %>
      <% end %>

      <h1 class="govuk-heading-l">
        <span class="govuk-caption-l"><%= condition_form.form.name %></span>
        <%= t("page_titles.routing_page") %>
      </h1>

      <%= govuk_summary_list do |summary_list|
        summary_list.with_row do |row|
          row.with_key { t("new_condition.routing_page_text") }
          row.with_value { condition_form.page.question_text }
          row.with_action(text: "Change", href: routing_page_path(condition_form.form.id), visually_hidden_text: "routing question")
        end;
      end %>

      <%= f.govuk_collection_select :answer_value, condition_form.routing_answer_options, :value, :label %>
      <%= f.govuk_collection_select :goto_page_id, condition_form.goto_page_options, :id, :question_text %>
      <%= f.govuk_submit t("save_and_continue") %>
    <% end %>
  </div>
</div>

app/views/pages/conditions/routing_page.html.erb
<% set_page_title(t("page_titles.routing_page")) %>
<% content_for :back_link, govuk_back_link_to(form_pages_path(form.id)) %>
<div class="govuk-grid-row">
  <div class="govuk-grid-column-two-thirds">
    <h1 class="govuk-heading-l">
      <span class="govuk-caption-l"><%= form.name %> </span>
      <%= t("page_titles.routing_page") %>
    </h1>

    <p class="govuk-body">
      <%= t("routing_page.body_text") %>
    </p>

    <%= form_with(model: form, url: set_routing_page_path(form.id), method: 'POST') do |f| %>
      <%= f.govuk_collection_radio_buttons :routing_page_id,
                                           form.qualifying_route_pages,
                                           :id, :question_text,
                                           legend: {
                                             text: t("routing_page.legend_text"),
                                             size: 'm' },
                                           hint:{
                                             text: t("routing_page.legend_hint_text") }
      %>
      <%= f.govuk_submit t("continue") %>
    <% end %>
  </div>
</div>